/*
 * Copyright (c) 2015 ezivkoc
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.page;

import wa.server.WAContext;
import wa.server.page.struct.WANavigation;
import wa.server.plugin.WAServiceStatus;
import zutil.io.file.FileUtil;
import zutil.log.LogUtil;
import zutil.net.http.HttpHeader;
import zutil.parser.DataNode;
import zutil.parser.Templator;
import zutil.plugin.PluginManager;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by Ziver on 2015-04-06.
 */
public class ServiceStatusPage implements WAPage {
    private static final Logger log = LogUtil.getLogger();
    public static final String NAVIGATION_NAME = "Service Status";
    private static final String TMPL_FILE = "WebContent/page/ServiceStatusPage.tmpl";

    private ArrayList<WAServiceStatus> services;


    public ServiceStatusPage(WAServiceStatus ss){
        services = new ArrayList<>();
        services.add(ss);
    }
    public ServiceStatusPage(PluginManager pluginManager){
        this.services = pluginManager.toArray(WAServiceStatus.class);

        WANavigation nav = WANavigation.createRootNav(ServicePage.NAVIGATION_NAME)
                .createSubNav(NAVIGATION_NAME);
        nav.setResource(this);
    }


    @Override
    public Templator htmlResponse(WAContext context,
                                  HttpHeader client_info,
                                  Map<String, Object> session,
                                  Map<String, String> cookie,
                                  Map<String, String> request) {

        try {
            Templator tmpl = new Templator(FileUtil.find(TMPL_FILE));
            tmpl.set("services", services);
            return tmpl;
        }catch (IOException e){
            log.log(Level.SEVERE, null, e);
        }
        return null;
    }

    public DataNode jsonResponse(WAContext context,
                                 HttpHeader client_info,
                                 Map<String, Object> session,
                                 Map<String, String> cookie,
                                 Map<String, String> request){
        DataNode root = new DataNode(DataNode.DataType.Map);
        if (request.containsKey("service_id") && request.containsKey("service_action")) {
            int index = Integer.parseInt(request.get("ServiceId"));
            if(0 > index || index > services.size()) {
                root.set("error", "Invalid service_id");
            }
            else {
                WAServiceStatus service = services.get(index);
                switch (request.get("ServiceAction")) {
                    case "start": service.start(); break;
                    case "stop": service.stop(); break;
                    default:
                        root.set("error", "Unknown action");
                }
            }
        }
        return root;
    }

}
